#include "eloproxy.h"

int main( int argc, char *argv[] ){
   
   int   s, ss, pd;
   struct   sockaddr_in eloproxy;
   struct sockaddr_in from;
   struct sockaddr_in sshd;
   struct  hostent *tsshd , *gethostbyname();
   int fromlen;
   int length;
   char inbuf[BUFSIZE];
   
   fd_set readfds, readfdsCopy, readsshd;
   int n,i,cc;
   int sockList[64], lastSock=0;
   int socksshd[64], lastsshd=0;
   
   if (argc != 5)
     {
	printf("Error en argumentos! \n");
	printf("Sintaxis: eloproxy <puerto_listen> <host_destino> <puerto_destino> <delta_t_en_segundos> \n");
	exit(-1);
     }

   delta = str2int(argv[4]);
   printf("delta:\t\t%d\nargv[4]:\t%s\n", delta, argv[4]);
   
   if (pipe(pfdm) < 0)             // tubera para matlab
     {
	perror("pipe");
	exit(1);
     }
   
   if ((pidm = fork()) < 0)        // crea proceso para ma$
     {
	perror("fork");
	exit(1);
     }
   
   if (pidm == 0)             // proceso matlab ...
     {
	dup2(pfdm[LEE], LEE);                       // dup$
	close(pfdm[ESCRIBE]);                       // cie$
	close(ESCRIBE);                             // cie$
	execlp("matlab","matlab","-nojvm", 0);      // eje$
	perror("exec");
	_exit(-1);
     }
   
   fm = fdopen(pfdm[ESCRIBE],"w");
   
   fprintf(fm,"subplot(2,2,1);\n");
   fprintf(fm,"xlabel('tiempo [seg]');\n");
   fprintf(fm,"ylabel('[bytes / seg]');\n");
   fprintf(fm,"title('-- tasa subida --');\n");
   fprintf(fm,"subplot(2,2,2);\n");
   fprintf(fm,"xlabel('tiempo [seg]');\n");
   fprintf(fm,"ylabel('[bytes / seg]');\n");
   fprintf(fm,"title('-- tasa bajada --');\n");
   fprintf(fm,"subplot(2,2,3);\n");
   fprintf(fm,"xlabel('tiempo [seg]');\n");
   fprintf(fm,"ylabel('[bytes / seg]');\n");
   fprintf(fm,"title('-- tasa promedio up --');\n");
   fprintf(fm,"subplot(2,2,4);\n");
   fprintf(fm,"xlabel('tiempo [seg]');\n");
   fprintf(fm,"ylabel('[bytes / seg]');\n");
   fprintf(fm,"title('-- tasa promedio down --');\n");
   fflush(fm);
   
   signal(SIGINT,salir);
   signal(SIGALRM,alarma);
   
   /* Obtencin de datos del sshd: nombre, familia y puerto */
   
   tsshd = gethostbyname(argv[2]);
   bcopy ( tsshd->h_addr, &(sshd.sin_addr), tsshd->h_length);
   sshd.sin_family = tsshd->h_addrtype;
   sshd.sin_port = htons(atoi(argv[3]));
   
   
   /* Socket para eloproxy.  El puerto es ingresado por consola. */
   
   eloproxy.sin_family = AF_INET;
   eloproxy.sin_addr.s_addr = htonl(INADDR_ANY);
   eloproxy.sin_port = htons(atoi(argv[1]));
   
   s = socket (AF_INET,SOCK_STREAM,0);
   reusePort(s);
   
   
   /* Se realiza el bind correspondiente para asociar el socket al servidor */
   if ( bind( s, (struct sockaddr *)&eloproxy, sizeof(eloproxy) ) ) {
      close(s);
      perror("binding name to stream socket");
      exit(-1);
   }
   
   printf("ELO PROXY para SSH  \n");
   printf("Puerto: %d\n\n", ntohs(eloproxy.sin_port));
   printf("SSHD: %s \n", argv[2]);
   printf("Puerto: %d\n\n", ntohs(sshd.sin_port));
   
   /* Escuchando por nuevas conexiones de clientes, hasta un mximo de 5 en cola*/
   listen(s,5);
   
   /* Se obtiene el largo de estructura de clientes (from). Este dato ser usado
    luego cuando se acepten conexiones provenientes de clientes */
   fromlen = sizeof(from);
   
   
   /* readfdsCopy contendr los descriptores que se desea monitorear con select
    Primero se limpia (FD_ZERO), y luego se agrega s (clientes) y la entrada estndar (0) */
   
   FD_ZERO(&readfdsCopy);
   FD_SET(s,&readfdsCopy);
   FD_SET(0,&readfdsCopy);
   alarm(1);
   
   for(;;)
     {
	/* Con memcpy se copian los descriptores contenidos en readfdsCopy a readfds
	 Las modificaciones se realizarn sobre readfdsCopy, pero se verifica si hay
	 actividad sobre readfds.
	 A continuacin se invoca a la funcin select, activndola con la opcin que
	 permite conocer cundo se produce lectura en alguno de los descriptores conteidos
	 en readfds */
	
	memcpy(&readfds, &readfdsCopy, sizeof(fd_set));
	n = select(FD_SETSIZE, &readfds, (fd_set *) 0, (fd_set *) 0, NULL);
	
	if (n > 0)
	  {
	     if (FD_ISSET(s, &readfds))      //Hubo actividad?
	       {
		  /*Se realiza un accept para cada nueva conexin */
		  //printf("Nueva conexin...\n");
		  sockList[lastSock++] = accept(s, (struct sockaddr *)&from, &fromlen);
		  FD_SET(sockList[lastSock-1], &readfdsCopy);
		  nRetconec++;        //se incrementan las variables para contar el nmero de conexiones
		  ntotconec++;
		  
		  /* En este punto se debe crear un nuevo socket para conexin con Proxy */
		  pd = socket (AF_INET,SOCK_STREAM,0);
		  reusePort(pd);
		  socksshd[lastsshd++]= pd;
		  FD_SET(socksshd[lastsshd-1], &readfdsCopy);
		  
		  
		  if (pd<0)
		    {
		       perror("abriendo socket stream");
		       exit(-1);
		    }
		  
		  if ( connect(pd, (struct sockaddr *)&sshd, sizeof(sshd)) < 0 )
		    {
		       close(pd);
		       perror("conectando socket stream");
		       exit(0);
		    }
	       }
	     cleanup(inbuf);    //limpiar buffer

	     /* Se chequea la entrada estndar. Si se ingres ENTER se imprimen los datos pedidos */
	     if (FD_ISSET(0, &readfds))
	       
	       if(cc=read(0, inbuf, sizeof(inbuf))>0)
		 {
		    printf("Nmero de conexiones nuevas establecidas: %d \n", nRetconec );
		    printf("Nmero de bytes de subida: %d \n", bytessubida);
		    printf("Nmero de bytes de bajada: %d \n", bytesbajada);
		    printf("Nmero de bytes totales: %d \n", totbytes);
		    printf("Nmero conexiones totales desde inicio: %d \n\n", ntotconec);
		    nRetconec=0;
		 }
	     
      for (i=0; i < lastSock; i++)
	       {
		  
		  /*Revisar cada punto de conexin desde clientes que intentan obtener pginas Web.
		   Para cada socket se invoca a la funcin EchoServe, que se encarga de realizar
		   el traspaso de paquetes desde el cliente hacia el proxy para que este ltimo le
		   devuelva la pgina Web solicitada.  En este proceso se cuenta en nmero de bytes
		   de la pgina descargada, cumpliendo la funcin de pesador.  Como se utiliza
		   la misma funcin tanto de ida como de vuelta, y lo que interesa es pesar los paquetes
		   de vuelta, se recurre a un flag (tercer argumento de EchoServer), el cual es seteado a uno
		   para que esta ltima realice el conteo */
		  
		  if (FD_ISSET(sockList[i], &readfds))
		    
		    if (EchoServe(sockList[i], socksshd[i], 0) < 0)
		      {
			 FD_CLR(sockList[i], &readfdsCopy);
			 FD_CLR(socksshd[i], &readfdsCopy);   //si se cierra una conexin se decrementa,
			 sockList[i] = sockList[--lastSock];   //tanto sockList como sockProxy
			 socksshd[i]= socksshd[--lastsshd];
			 i--;
		      }
		  
		  /*Conexiones desde el proxy hacia el cliente */
		  
		  if (FD_ISSET(socksshd[i], &readfds))
		    
		    if (EchoServe(socksshd[i], sockList[i], 1) < 0)
		      {
			 FD_CLR(sockList[i], &readfdsCopy);
			 FD_CLR(socksshd[i], &readfdsCopy);   //dem al anterior
			 sockList[i] = sockList[--lastSock];
			 socksshd[i]= socksshd[--lastsshd];
			 i--;
			 
		      }
	       }
	     
	  }
     }
}


/*esta rutina debe contactarse con el proxy, para recibir los paquetes
 que ste enva al cliente, pesarlos, y reenviarlos al cliente. Se realiza
 el traspaso de paquetes de un lado hacia el otro, y viceversa */

int EchoServe(int from, int to, int flag)
{
   char buf[BUFSIZE];
   int rc;
   
   for(;;)
     {
	
	if( (rc=read(from, buf, sizeof(buf))) < 0)
	  perror("receiving stream  message");
	
	
	if (rc > 0)
	  {
	     
	     if( flag==1)              //flag==1 entonces proviene del sshd, que se considera trfico de bajada.
	       bytesbajada += rc;
	     else  
	       bytessubida += rc;    //flag==0 entonces proviene del cliente lo que se considera de subida.
	     
	     totbytes=bytesbajada+bytessubida;
	     
	     if (send(to, buf, rc, 0) <0 )
	       perror("sending stream message");
	     return(1);
	  }
	
	else
	  {
	     //printf("Desconectado...\n");    se cierra una conexin
	     close(from);
	     close(to);
	     return(-1);
	  }
     }
}


/***************** REUSAR PUERTO ***************************/
void reusePort(int s)
{
   int one=1;
   
   if ( setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(char *) &one,sizeof(one)) == -1 )
     {
	printf("error in setsockopt,SO_REUSEPORT \n");
	exit(-1);
     }
}


/******************************** LIMPIAR BUFFER ***********************************/
void cleanup(char *buf){
   int i;
   for(i=0; i<BUFSIZE; i++) buf[i]='\0';
}

void alarma(void)
{
   int t_subida=0;
   int t_bajada=0;
   
   segundos++;	
   
   fprintf(fm,"p_up(%d)=sum(t_up)/length(t_up);\n", segundos);
   fflush(fm);
   fprintf(fm,"subplot(2,2,3);\n");fflush(fm);
   fprintf(fm,"plot(p_up);\n");fflush(fm);
   fprintf(fm,"xlabel('tiempo [seg]');\n");fflush(fm);
   fprintf(fm,"ylabel('[bytes / seg]');\n");fflush(fm);
   fprintf(fm,"title('-- tasa promedio up --');\n");fflush(fm);
   fprintf(fm,"p_down(%d)=sum(t_down)/length(t_down);\n", segundos);
   fflush(fm);
   fprintf(fm,"subplot(2,2,4);\n");fflush(fm);
   fprintf(fm,"plot(p_down);\n");fflush(fm);
   fprintf(fm,"xlabel('tiempo [seg]');\n");fflush(fm);
   fprintf(fm,"ylabel('[bytes / seg]');\n");fflush(fm);
   fprintf(fm,"title('-- tasa promedio down --');\n");fflush(fm);
   
   
   if ((segundos%delta)==0)
     {
	t_subida=(bytessubida-aux_subida)/delta;
	t_bajada=(bytesbajada-aux_bajada)/delta;
	aux_subida=bytessubida;
	aux_bajada=bytesbajada;
	
	fprintf(fm,"t_up(%d)=%d;\n", c1, t_subida);
	fflush(fm);
	fprintf(fm,"t_down(%d)=%d;\n", c1, t_bajada);
	fflush(fm);
	fprintf(fm,"cuenta(%d)=%d;\n", c1, c1*delta);
	fflush(fm);
	fprintf(fm,"subplot(2,2,1);\n");fflush(fm);
	fprintf(fm,"plot(cuenta,t_up);\n");fflush(fm);
	fprintf(fm,"xlabel('tiempo [seg]');\n");fflush(fm);
	fprintf(fm,"ylabel('[bytes / seg]');\n");fflush(fm);
	fprintf(fm,"title('-- tasa subida --');\n");fflush(fm);
	fprintf(fm,"subplot(2,2,2);\n");fflush(fm);
	fprintf(fm,"plot(cuenta,t_down);\n");fflush(fm);
	fprintf(fm,"xlabel('tiempo [seg]');\n");fflush(fm);
	fprintf(fm,"ylabel('[bytes / seg]');\n");fflush(fm);
	fprintf(fm,"title('-- tasa bajada --');\n");fflush(fm);
	
	c1++;
     }
   
   alarm(1);
}

void salir()                       // funcin de trmino ...
{
   printf("\nctrl-c atrapada:\t Terminando las tuberias\n\n");// mensaje final
   fprintf(fm, "\n exit\n");fflush(fm);                       // cierra matlab
   fclose(fm);                                                // cierra tubera con$
   
   // para evitar dejar los procesos hijos como "zombies
   waitpid(pidm, &status, 0);
   exit(0);
}


int str2int (char *ss)
{
   //funcin para pasar de string a enteros.
   int ii,xx=0,zz=0,pp;
   zz=strlen(ss)-1;
   for(ii=0; ii<=zz ;ii++)
     {
	if ( isdigit( *(ss+ii) ) )
	  {  
	     pp= (int) *(ss+ii)-48;
	     xx+= pow(10,zz-ii) * pp;
	  }
	else
	  {  
	     return 0;
	  }	
     }   
   return xx;
}

